Draft Clone: Difference between revisions

From FreeCAD Documentation
(See also Draft Scale)
(Button text.)
 
(63 intermediate revisions by 7 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>

<!--T:19-->
{{Docnav
|[[Draft_Stretch|Stretch]]
|[[Draft_OrthoArray|OrthoArray]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Stretch.svg
|IconR=Draft_OrthoArray.svg
|IconC=Workbench_Draft.svg
}}

<!--T:1-->
<!--T:1-->
{{GuiCommand
{{GuiCommand
|Name=Draft Clone
|Name=Draft Clone
|MenuLocation=Draft → Clone
|MenuLocation=Modification → Clone
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|Workbenches=[[Draft_Workbench|Draft]], [[Arch_Workbench|Arch]]
|Shortcut={{KEY|C}} {{KEY|L}}
|SeeAlso=[[Draft Move]], [[Draft Scale|Draft Scale]]
|SeeAlso=[[Draft_Scale|Draft Scale]]
}}
}}


==Description== <!--T:2-->
==Description== <!--T:22-->
The Draft Clone tool produces linked copies of a selected shape. This means that if the original object changes its shape and properties, all clones change as well. Nevertheless, each clone retains its unique position, rotation, and scale, as well as its view properties like shape color, line width, and transparency.


<!--T:2-->
The Clone tool can be used on 2D shapes created with the [[Draft Workbench]], but can also be used on many types of 3D objects such as those created with the [[Part Workbench|Part]], [[PartDesign Workbench|PartDesign]], or [[Arch Workbench]]es.
The [[Image:Draft_Clone.svg|24px]] '''Draft Clone''' command creates linked copies, clones, of selected objects. The shape of a clone is parametric, it will update if its source object changes. But a clone does have its own position, rotation, and scale, and its own [[Property_editor|View properties]]. For [[Arch_Workbench|Arch]] objects the command creates a special type of clone: an Arch clone.


<!--T:10-->
To create simple copies, that are completely independent from an original object, use [[Draft Move]], [[Draft Rotate]], and [[Draft Scale]]. To position copies in an orthogonal array use [[Draft Array]]; to position copies along a path use [[Draft PathArray]]; to position copies at specified points use [[Draft PointArray]].
The command can be used on 2D objects created with the [[Draft_Workbench|Draft Workbench]] or [[Sketcher_Workbench|Sketcher Workbench]], but also on many 3D objects such as those created with the [[Part_Workbench|Part Workbench]], [[PartDesign_Workbench|PartDesign Workbench]] or [[Arch_Workbench|Arch Workbench]]. Clones of 2D objects can be used in [[PartDesign_Body|PartDesign Bodies]].


</translate>
<!--T:3-->
[[Image:Draft_Clone_example.jpg|400px]]
[[Image:Draft_Clone_example.jpg|400px]]
<translate>
<!--T:3-->
{{Caption|Draft Clone next to its source object}}


==How to use== <!--T:4-->
==Usage== <!--T:23-->
# Select objects you wish to clone
# Press the {{KEY|[[Image:Draft Clone.png|16px]] [[Draft Clone]]}} button


==Options== <!--T:9-->
<!--T:4-->
# Optionally select one or more objects.
* Clones of 2D objects (Draft or Sketch) will also be 2D objects, and therefore can be used as such for [[PartDesign Workbench|Part Design]].
# There are several ways to invoke the command:
* All [[Arch Workbench|Arch]] objects have the possibility to behave as a clone (using their CloneOf property). If you use the Draft Clone tool on a selected Arch object, you will produce such an Arch cloned object instead of a regular Draft clone.
#* Press the {{Button|[[Image:Draft_Clone.svg|16px]] [[Draft_Clone|Clone]]}} button.
#* Select the {{MenuCommand|Modification → [[Image:Draft_Clone.svg|16px]] Clone}} option from the menu.
#* Use the keyboard shortcut: {{KEY|C}} then {{KEY|L}}.
# If you have not yet selected an object: select an object in the [[3D_view|3D view]].


==Properties== <!--T:5-->
==Properties== <!--T:26-->
* {{PropertyData|Scale}}: Specifies an optional scale factor for the clone
* {{PropertyData|Fuse}}: If this clone is using several objects, this specifies if the result is a fusion or a compound {{Version|0.17}}
* The result of the [[Draft Scale]] tool is also a clone
* No sketches can be mapped to faces of a clone. That is at the moment a known limitation.


==Scripting== <!--T:6-->
<!--T:28-->
See also: [[property_editor|Property editor]].
The Clone tool can by used in [[macros]] and from the python console by using the following function:

<!--T:24-->
An object created with the Draft Clone command is derived from a [[Part_Part2DObject|Part Part2DObject]], a [[Part_Feature|Part Feature]] object or, if an Arch Clone is created, from the object type of the source object. It inherits all properties from that object. A clone derived from one of the first two objects also has the following additional properties:

===Data=== <!--T:29-->

<!--T:30-->
{{TitleProperty|Draft}}

<!--T:5-->
* {{PropertyData|Fuse|Bool}}: specifies if overlapping shapes in the clone are fused or not.
* {{PropertyData|Objects|LinkListGlobal}}: specifies the objects that are cloned.
* {{PropertyData|Scale|Vector}}: specifies the X, Y and Z scale factors.

==Scripting== <!--T:27-->

<!--T:6-->
See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation] and [[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]].

<!--T:16-->
To create a clone use the {{incode|make_clone}} method ({{Version|0.19}}) of the Draft module. This method replaces the deprecated {{incode|clone}} method.


</translate>
</translate>
{{Code|code=
{{Code|code=
cloned_object = make_clone(obj, delta=None, forcedraft=False)
clone (obj,[delta])
}}
}}
<translate>
<translate>

<!--T:7-->
<!--T:7-->
* {{incode|obj}} contains the objects to be cloned. It is either a single object or a list of objects.
* Makes a clone of the given object(s).
* {{incode|delta}} is the displacement vector to be applied to the clone.
* The clone is an exact, linked copy of the given object.
* If {{incode|forcedraft}} is {{incode|False}} and {{incode|obj}} contains a single [[Arch_Workbench|Arch object]] an Arch Clone is created. Set {{incode|forcedraft}} to {{incode|True}} to create a Draft Clone instead.
* If the original object changes, the final object changes too. Optionally, you can give a delta Vector to move the clone away from the original position.
* {{incode|cloned_object}} is returned with the clone object.


<!--T:8-->
<!--T:8-->
Example:
Example:

</translate>
</translate>
{{Code|code=
{{Code|code=
import FreeCAD as App
import Draft
import Draft
Draft.clone(FreeCAD.ActiveDocument.ActiveObject)


doc = App.newDocument()

place = App.Placement(App.Vector(1000, 0, 0), App.Rotation())
polygon1 = Draft.make_polygon(3, 750)
polygon2 = Draft.make_polygon(5, 750, placement=place)

vector = App.Vector(2600, 500, 0)
cloned_object = Draft.clone([polygon1, polygon2], delta=vector)

cloned_object.Fuse = True

doc.recompute()
}}
}}
<translate>



{{clear}}
<!--T:18-->
{{Docnav
|[[Draft_Stretch|Stretch]]
|[[Draft_OrthoArray|OrthoArray]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Stretch.svg
|IconR=Draft_OrthoArray.svg
|IconC=Workbench_Draft.svg
}}

</translate>
{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 17:08, 3 December 2023

Draft Clone

Menu location
Modification → Clone
Workbenches
Draft, Arch
Default shortcut
C L
Introduced in version
-
See also
Draft Scale

Description

The Draft Clone command creates linked copies, clones, of selected objects. The shape of a clone is parametric, it will update if its source object changes. But a clone does have its own position, rotation, and scale, and its own View properties. For Arch objects the command creates a special type of clone: an Arch clone.

The command can be used on 2D objects created with the Draft Workbench or Sketcher Workbench, but also on many 3D objects such as those created with the Part Workbench, PartDesign Workbench or Arch Workbench. Clones of 2D objects can be used in PartDesign Bodies.

Draft Clone next to its source object

Usage

  1. Optionally select one or more objects.
  2. There are several ways to invoke the command:
    • Press the Clone button.
    • Select the Modification → Clone option from the menu.
    • Use the keyboard shortcut: C then L.
  3. If you have not yet selected an object: select an object in the 3D view.

Properties

See also: Property editor.

An object created with the Draft Clone command is derived from a Part Part2DObject, a Part Feature object or, if an Arch Clone is created, from the object type of the source object. It inherits all properties from that object. A clone derived from one of the first two objects also has the following additional properties:

Data

Draft

  • DataFuse (Bool): specifies if overlapping shapes in the clone are fused or not.
  • DataObjects (LinkListGlobal): specifies the objects that are cloned.
  • DataScale (Vector): specifies the X, Y and Z scale factors.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a clone use the make_clone method (introduced in version 0.19) of the Draft module. This method replaces the deprecated clone method.

cloned_object = make_clone(obj, delta=None, forcedraft=False)
  • obj contains the objects to be cloned. It is either a single object or a list of objects.
  • delta is the displacement vector to be applied to the clone.
  • If forcedraft is False and obj contains a single Arch object an Arch Clone is created. Set forcedraft to True to create a Draft Clone instead.
  • cloned_object is returned with the clone object.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

place = App.Placement(App.Vector(1000, 0, 0), App.Rotation())
polygon1 = Draft.make_polygon(3, 750)
polygon2 = Draft.make_polygon(5, 750, placement=place)

vector = App.Vector(2600, 500, 0)
cloned_object = Draft.clone([polygon1, polygon2], delta=vector)

cloned_object.Fuse = True

doc.recompute()